/**********************************************************************/
/*                                                                    */
/*   Licensed Materials - Property of IBM.                            */
/*   IBM XL C/C++ for Blue Gene, V12.1                                */
/*   (5799-AG1)                                                       */
/*   Copyright IBM Corp. 2003, 2007.                                  */
/*   All Rights Reserved.                                             */
/*   US Government Users Restricted Rights -                          */
/*   Use, duplication or disclosure restricted by                     */
/*   GSA ADP Schedule Contract with IBM Corp.                         */
/*                                                                    */
/**********************************************************************/

#ifndef __IBM_VACPP_varargs_h
#define __IBM_VACPP_varargs_h 1

#ifdef __IBM_PP_WARNING
#  warning "GCC no longer implements <varargs.h>."
#  warning "Revise your code to use <stdarg.h>."
#else
#  error "<varargs.h> is not a standard header file."
#  error "Revise your code to use <stdarg.h>."
#endif

#if __cplusplus
extern "C" {
#endif

#undef va_dcl
#undef va_start
#undef va_arg
#undef va_end
#undef __va_copy

#if __64BIT__

# ifndef __BUILTIN_VA_LIST
# define __BUILTIN_VA_LIST
  typedef char *__builtin_va_list;
# endif

# define va_dcl long va_alist;
# define va_start(__list) (__list) = (char *) &va_alist
# define va_arg(__list,__t) __extension__ ((__typeof__(__typeof__(__t) *)) \
         ((__list) += sizeof(long) > sizeof(__t) ? sizeof(long) : sizeof(__t)))[-1]
# define va_end(__list)
# define __va_copy(__list1,__list2) (__list1) = (__list2)

#else /* 32 bit */

# if __cplusplus
#  ifndef __BUILTIN_VA_LIST
#  define __BUILTIN_VA_LIST
   typedef struct __builtin_va_list_struct {
     unsigned char gpr;
     unsigned char fpr;
     unsigned char reserved[2];
     void *overflow_arg_area;
     void *reg_save_area;
   } __builtin_va_list[1];
#  endif
# endif

  extern void* __va_arg(void*, int);

# undef va_alist
# define va_alist __va_alist

  __extension__ typedef int __va_alist_t __attribute__((__mode__(__word__)));

# define va_dcl __va_alist_t __va_alist;
# define va_start(__list) (__vastart(&(__list)), (((__list)[0].gpr > 8) ? \
         (void) ((__list)[0].overflow_arg_area = (((int *) (__list)[0].overflow_arg_area)-1)) \
         : (void) 0) ,(__list)[0].gpr--)
# define va_arg(__list,__t)  __extension__ (*((__typeof__(__typeof__(__t) *)) \
         __va_arg( (__list), __builtin_va_arg_incr((__typeof__(__typeof__(__t) *))0)) ))
# define va_end(__list) ((void*)0)
# define __va_copy(__list1,__list2) ((__list1)[0] = (__list2)[0])

#endif /* 32-bit */

#if ! __cplusplus && !(__STDC__ && __STDC_VERSION__ < 199901L)
# ifdef va_copy
#  undef va_copy
# endif
# define va_copy(__list1,__list2) ((void) (__va_copy(__list1,__list2)))
#endif

#ifndef __GNUC_VA_LIST
#define __GNUC_VA_LIST
typedef __builtin_va_list __gnuc_va_list;
#endif

#if !defined(__VA_LIST) && !defined(_VA_LIST_DEFINED) && !defined(_VA_LIST) && !defined(_VA_LIST_T_H) && !defined(__va_list__)
#define __VA_LIST
#define _VA_LIST_DEFINED
#define _VA_LIST
#define _VA_LIST_T_H
#define __va_list__
typedef __builtin_va_list va_list;
#endif

#if __cplusplus
}
#endif

#endif /* __IBM_VACPP_varargs_h */
