/**********************************************************************/
/*                                                                    */
/* COMPONENT_NAME:  smprt (SMP Runtime Library)                       */
/* COMPONENT_ID:    (5799-AH1)                                        */
/*                                                                    */
/*   Licensed Materials - Property of IBM.                            */
/*   IBM XL C/C++ for Blue Gene, V12.1                                */
/*   (5799-AG1)                                                       */
/*   IBM XL Fortran for Blue Gene, V14.1                              */
/*   (5799-AH1)                                                       */
/*   Copyright IBM Corp. 1994, 2012.                                  */
/*   All Rights Reserved.                                             */
/*   US Government Users Restricted Rights -                          */
/*   Use, duplication or disclosure restricted by                     */
/*   GSA ADP Schedule Contract with IBM Corp.                         */
/*                                                                    */
/**********************************************************************/
/*  SCCS ID STRING    13  1.16 4/4/12 21:33:20        1/17/13 15:31:12  */

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __IBM_TRANSACTIONAL_MEMORY__
  void tm_print_stats(void);
  void tm_print_all_stats(void);
  void se_print_stats(void);
  int tm_get_thread_id();
  int tm_get_total_retries(int tid);
  int tm_get_total_transactions(int tid);
  int tm_get_total_committed(int tid);
  int tm_get_total_serialized(int tid);
  int tm_get_avg_retries(int tid);
  int tm_get_total_last_retries(int tid);
  void tm_get_filename(int tid, char * filename);
  int tm_get_last_transaction_lineno(int tid);
  
  typedef struct TmReport_s {
    unsigned long hwThreadId;
    unsigned long totalTransactions;
    unsigned long totalRollbacks;
    unsigned long totalSerializedJMV;
    unsigned long totalSerializedMAXRB;
    unsigned long totalSerializedOTHER;
  } TmReport_t;
  void tm_get_stats(TmReport_t *arg);
  void tm_get_all_stats(TmReport_t *arg);
  void speculative_printf(const char* format, ...);
  void reset_speculation_mode();
#endif

#ifdef __IBM_THREAD_LEVEL_SPECULATIVE_EXECUTION__
  #include "omp.h"
  typedef struct SeReport_s {
    unsigned long totalNONSpecCommitted;
    unsigned long totalSpecCommitted;
    unsigned long totalRollbacks;
    unsigned long totalSerializedJMV;
    unsigned long totalSerializedMAXRB;
    unsigned long totalSerializedOTHER;
  } SeReport_t;
  void se_get_all_stats(SeReport_t *arg);
  void se_print_stats(void);
#ifndef __IBM_TRANSACTIONAL_MEMORY__
  void speculative_printf(const char* format, ...);
  void reset_speculation_mode();
#endif
#endif

#ifdef __cplusplus
}
#endif

