#ifndef PRINTING_H
#define PRINTING_H

#include <stdint.h>  /* for int32_t, int64_t */

#define HAVE_SNPRINTF
#define HAVE_VSNPRINTF
#define HAVE_WRITE
#define HAVE_GETTIMEOFDAY

#define MAX_THREADS 128
#define MAX_MESSAGE_LENGTH 256

void print(const char *format, ...);
void print_callback(const char *source, int32_t thread,
    const char *format, ...);

void add_indent(int32_t thread);
void subtract_indent(int32_t thread);

void init_timing(void);
double current_time(void);

#endif
