#include <omp.h>
#include <stdio.h>

#define SCREEN_WIDTH 80
#define TABLE_SIZE SCREEN_WIDTH*20

int main() {
    int i, j;
    int prime[TABLE_SIZE + 1];

    #pragma omp parallel
    {
        printf("Greetings from thread %d.\n", omp_get_thread_num());
    }

    /* Also try schedule(dynamic, SCREEN_WIDTH) for more random output */
    #pragma omp parallel for shared(prime) private(i, j)
    for(i = 1; i <= TABLE_SIZE; i ++) {
        prime[i] = 1;  /* assume i is prime until proven otherwise */
        for(j = 2; j < i; j ++) {
            if(i % j == 0) {
                prime[i] = 0;  /* j divides i, so i is not prime */
                break;
            }
        }
    }

    printf("Table of primes, marked with '*':\n");
    for(i = 1; i <= TABLE_SIZE; i ++) {
        putchar(prime[i] ? '*' : '-');
        if(i % SCREEN_WIDTH == 0) printf("\n");
    }

    return 0;
}

